diff --git a/src/main/java/net/minecraft/core/item/ItemFlag.java b/src/main/java/net/minecraft/core/item/ItemFlag.java
index 85a5da29d..74ec0a021 100644
--- a/src/main/java/net/minecraft/core/item/ItemFlag.java
+++ b/src/main/java/net/minecraft/core/item/ItemFlag.java
@@ -7,6 +7,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.entity.TileEntityFlag;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
+import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
@@ -35,13 +36,13 @@ public class ItemFlag extends Item
 			if (flag != null) {
 				CompoundTag flagData = stack.getData().getCompoundOrDefault("FlagData", new CompoundTag());
 				if (hasFlagBeenDrawnOn(stack) && doesFlagContainDyes(stack)) {
-					entityplayer.addChatMessage("flag.overwrite");
+					entityplayer.sendStatusMessage(I18n.getInstance().translateKey("flag.overwrite"));
 					return false;
 				}
 				flag.copyFlagNBT(flagData);
                 flagData.putString("Owner", entityplayer.username); // Sets the owner of the copied flag to the current player so they can actually modify the flag once they place it
 				stack.getData().putCompound("FlagData", flagData);
-				entityplayer.addChatMessage("flag.copied");
+				entityplayer.sendStatusMessage(I18n.getInstance().translateKey("flag.copied"));
 				return true;
 			}
 		}
diff --git a/src/main/java/net/minecraft/core/item/ItemMap.java b/src/main/java/net/minecraft/core/item/ItemMap.java
index ef4d2abb1..b82cb45e3 100644
--- a/src/main/java/net/minecraft/core/item/ItemMap.java
+++ b/src/main/java/net/minecraft/core/item/ItemMap.java
@@ -68,7 +68,7 @@ public class ItemMap extends ItemComplex
 			TileEntityFlag flag = (TileEntityFlag) world.getBlockTileEntity(blockX, blockY, blockZ);
 			boolean canCreateMap = mapData.createNewWaypoint(flag);
 			if(!canCreateMap)
-				entityplayer.addChatMessage("flag.full");
+				entityplayer.sendTranslatedChatMessage("flag.full");
 			return canCreateMap;
 		}
 		return false;
diff --git a/src/main/java/net/minecraft/core/net/command/commands/TimeCommand.java b/src/main/java/net/minecraft/core/net/command/commands/TimeCommand.java
index 772d0c743..1c9b318f6 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/TimeCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/TimeCommand.java
@@ -109,7 +109,7 @@ public class TimeCommand extends Command {
 			}
 		}
 
-		SeasonManager seasonManager = world.seasonManager;
+		SeasonManager seasonManager = world.getSeasonManager();
 		if (seasonManager instanceof SeasonManagerCycle)
 		{
 			SeasonManagerCycle cycleManager = (SeasonManagerCycle) seasonManager;
@@ -121,7 +121,7 @@ public class TimeCommand extends Command {
 				int yearLength = 0;
 				Integer seasonStart = null;
 
-				List<Season> seasons = world.seasonManager.getSeasons();
+				List<Season> seasons = world.getSeasonManager().getSeasons();
 				for(Season season : seasons) {
 					if(season == seasonEntry.getValue()) seasonStart = yearLength;
 					yearLength += cycleManager.getConfig().getSeasonLength(season) * Global.DAY_LENGTH_TICKS;
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet3Chat.java b/src/main/java/net/minecraft/core/net/packet/Packet3Chat.java
index 8e77ba265..73bd3618c 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet3Chat.java
+++ b/src/main/java/net/minecraft/core/net/packet/Packet3Chat.java
@@ -6,72 +6,65 @@ import net.minecraft.core.util.helper.AES;
 import java.io.*;
 import java.security.Key;
 
-// Referenced classes of package net.minecraft.src:
-//            Packet, NetHandler
+public class Packet3Chat extends Packet {
+	
+	public static final String ENCRYPTION_ERROR_MESSAGE = "This crash is caused by outdated Java, please update to 8u161 or newer! If your Java version is out of date due to a technical requirement, please add the JCE Unlimited Strength Jurisdiction Policy Files to your installation. https://www.oracle.com/java/technologies/javase-jce-all-downloads.html";
+	
+	public String message;
+	public int type;
+	public boolean encrypted;
 
-public class Packet3Chat extends Packet
-{
+	public Packet3Chat() {
+		
+	}
 
-    public Packet3Chat()
-    {
-    }
+	public Packet3Chat(String string) {
+		this(string, 0, null);
+	}
 
-    public Packet3Chat(String s)
-    {
-        if(s.length() > 512)
-        {
-            s = s.substring(0, 512);
-        }
-        message = s;
-        encrypted = false;
-    }
+	public Packet3Chat(String string, Key key) {
+		this(string, 0, key);
+	}
+	
+	public Packet3Chat(String string, int type, Key key) {
+		if(string.length() > 512) {
+			string = string.substring(0, 512);
+		}
+		if(key != null) {
+			try {
+				message = AES.encrypt(string, key);
+				encrypted = true;
+			}catch (Exception e) {
+				throw new RuntimeException(ENCRYPTION_ERROR_MESSAGE, e);
+			}
+		}else {
+			this.message = string;
+			this.encrypted = false;
+		}
+		this.type = type;
+	}
 
-    public Packet3Chat(String s, Key AESKey)
-    {
-        if(s.length() > 512)
-        {
-            s = s.substring(0, 512);
-        }
-        try
-        {
-            message = AES.encrypt(s, AESKey);
-        }
-        catch (Exception e)
-        {
-        	String msg = "This crash is caused by outdated Java. Your Java version is more than five years out of date! Please update to 8u161 or newer. If your Java version is out of date due to a technical requirement, please add the JCE Unlimited Strength Jurisdiction Policy Files to your installation. https://www.oracle.com/java/technologies/javase-jce-all-downloads.html";
-            throw new RuntimeException(msg, e);
-        }
-        encrypted = true;
-    }
+	@Override
+	public void readPacketData(DataInputStream in) throws IOException {
+		type = in.readByte();
+		message = readString(in, 1024);
+		encrypted = in.readBoolean();
+	}
 
-    @Override
-	public void readPacketData(DataInputStream dis)
-        throws IOException
-    {
-        message = readString(dis, 1024);
-        encrypted = dis.readBoolean();
-    }
+	@Override
+	public void writePacketData(DataOutputStream out) throws IOException {
+		out.writeByte(type);
+		writeString(message, out);
+		out.writeBoolean(encrypted);
+	}
 
-    @Override
-	public void writePacketData(DataOutputStream dos)
-        throws IOException
-    {
-        writeString(message, dos);
-        dos.writeBoolean(encrypted);
-    }
+	@Override
+	public void processPacket(NetHandler netHandler) {
+		netHandler.handleChat(this);
+	}
 
-    @Override
-	public void processPacket(NetHandler netHandler)
-    {
-        netHandler.handleChat(this);
-    }
-
-    @Override
-	public int getPacketSize()
-    {
-        return message.length();
-    }
-
-    public String message;
-    public boolean encrypted;
+	@Override
+	public int getPacketSize() {
+		return message.length() + 1;
+	}
 }
diff --git a/src/main/java/net/minecraft/core/player/inventory/ContainerPlayerCreative.java b/src/main/java/net/minecraft/core/player/inventory/ContainerPlayerCreative.java
index e503187de..72e607dcb 100644
--- a/src/main/java/net/minecraft/core/player/inventory/ContainerPlayerCreative.java
+++ b/src/main/java/net/minecraft/core/player/inventory/ContainerPlayerCreative.java
@@ -36,7 +36,7 @@ public class ContainerPlayerCreative extends ContainerPlayer
 			int x = i % 6;
 			int y = i / 6;
 			
-			addSlot(new SlotCreative(creativeSlotsStart + i, 174 + (x * 18), 30 + (y * 18), creativeItems.get(i)));
+			addSlot(new SlotCreative(creativeSlotsStart + i, 184 + (x * 18), 30 + (y * 18), creativeItems.get(i)));
 		}
 		
 		searchPage("");
diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index 59cbacaac..caebad2d4 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -119,7 +119,7 @@ public class World implements WorldSource {
 
     public AuroraProvider auroraProvider;
 
-    public final SeasonManager seasonManager;
+    private final SeasonManager seasonManager;
 
     public final WeatherManager weatherManager;
 
@@ -414,6 +414,7 @@ public class World implements WorldSource {
         return Block.getBlock(getBlockId(x, y, z));
     }
 
+    @Override
     public double getBlockTemperature(int x, int z)
     {
         if(x < 0xfe17b800 || z < 0xfe17b800 || x >= 0x1e84800 || z > 0x1e84800)
@@ -445,7 +446,7 @@ public class World implements WorldSource {
             return temperature;
         }
     }
-    
+    @Override
     public double getBlockHumidity(int x, int z)
     {
         if(x < 0xfe17b800 || z < 0xfe17b800 || x >= 0x1e84800 || z > 0x1e84800)
@@ -477,6 +478,12 @@ public class World implements WorldSource {
             return humidity;
         }
     }
+
+    @Override
+    public SeasonManager getSeasonManager() {
+        return seasonManager;
+    }
+
     public double getBlockVariety(int x, int z)
     {
         if(x < 0xfe17b800 || z < 0xfe17b800 || x >= 0x1e84800 || z > 0x1e84800)
@@ -508,7 +515,8 @@ public class World implements WorldSource {
             return variety;
         }
     }
-    
+
+    @Override
     public Biome getBlockBiome(int x, int y, int z)
     {
         if(x < 0xfe17b800 || z < 0xfe17b800 || x >= 0x1e84800 || z > 0x1e84800)
diff --git a/src/main/java/net/minecraft/core/world/WorldSource.java b/src/main/java/net/minecraft/core/world/WorldSource.java
index 06c6becbe..de1b74b9b 100644
--- a/src/main/java/net/minecraft/core/world/WorldSource.java
+++ b/src/main/java/net/minecraft/core/world/WorldSource.java
@@ -3,7 +3,10 @@ package net.minecraft.core.world;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
+import net.minecraft.core.world.season.Season;
+import net.minecraft.core.world.season.SeasonManager;
 
 public interface WorldSource
 {
@@ -25,4 +28,8 @@ public interface WorldSource
     boolean isBlockOpaqueCube(int x, int y, int z);
 
     boolean isBlockNormalCube(int x, int y, int z);
+    double getBlockTemperature(int x, int z);
+    double getBlockHumidity(int x, int z);
+    SeasonManager getSeasonManager();
+    Biome getBlockBiome(int x, int y, int z);
 }
diff --git a/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java b/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
index 8e349da2d..805af9a82 100644
--- a/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
+++ b/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
@@ -9,7 +9,9 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
+import net.minecraft.core.world.season.SeasonManager;
 
 public class ChunkCache
     implements WorldSource
@@ -230,4 +232,24 @@ public class ChunkCache
             return block.blockMaterial.blocksMotion() && block.renderAsNormalBlock();
         }
     }
+
+    @Override
+    public double getBlockTemperature(int x, int z) {
+        return worldObj.getBlockTemperature(x, z);
+    }
+
+    @Override
+    public double getBlockHumidity(int x, int z) {
+        return worldObj.getBlockHumidity(x, z);
+    }
+
+    @Override
+    public SeasonManager getSeasonManager() {
+        return worldObj.getSeasonManager();
+    }
+
+    @Override
+    public Biome getBlockBiome(int x, int y, int z) {
+        return worldObj.getBlockBiome(x, y, z);
+    }
 }
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index 7ea2c70fe..806b1a267 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -286,12 +286,25 @@ public class ChunkDecoratorOverworld
             (new WorldFeatureSugarCaneTall()).generate(world, rand, i18, i21, i23);
         }
 
-        byte byteMeadow = 0;
+        byte byteOrchid = 0;
+        if (biome == Biomes.OVERWORLD_BIRCH_FOREST) {
+            byteOrchid = 3;
+        }
         if (biome == Biomes.OVERWORLD_SEASONAL_FOREST) {
-            byteMeadow = 1;
+            byteOrchid = 1;
+        }
+        for (int l14 = 0; l14 < byteOrchid; l14++) {
+            int blockId = Block.flowerPink.id;
+
+            int l19 = x + rand.nextInt(16) + 8;
+            int k22 = rand.nextInt(world.getHeightBlocks());
+            int j24 = z + rand.nextInt(16) + 8;
+            (new WorldFeatureTallGrass(blockId)).generate(world, rand, l19, k22, j24);
         }
+
+        byte byteMeadow = 0;
         if (biome == Biomes.OVERWORLD_MEADOW) {
-            byteMeadow = 2;
+            byteMeadow = 3;
         }
         if (biome == Biomes.OVERWORLD_BOREAL_FOREST) {
             byteMeadow = 2;
@@ -300,16 +313,43 @@ public class ChunkDecoratorOverworld
             byteMeadow = 1;
         }
         for (int l14 = 0; l14 < byteMeadow; l14++) {
-            int blockId = Block.flowerYellow.id;
-            if (rand.nextInt(3) != 0) {
+            int blockId = Block.flowerPurple.id;
+            if (rand.nextInt(12) == 0) {
                 blockId = Block.flowerRed.id;
             }
+            if (rand.nextInt(6) == 0) {
+                blockId = Block.flowerYellow.id;
+            }
             int l19 = x + rand.nextInt(16) + 8;
             int k22 = rand.nextInt(world.getHeightBlocks());
             int j24 = z + rand.nextInt(16) + 8;
             (new WorldFeatureTallGrass(blockId)).generate(world, rand, l19, k22, j24);
         }
 
+        byte byteBluebells = 0;
+        if (biome == Biomes.OVERWORLD_FOREST) {
+            byteBluebells = 2;
+        }
+        if (biome == Biomes.OVERWORLD_SWAMPLAND) {
+            byteBluebells = 3;
+        }
+        if (biome == Biomes.OVERWORLD_RAINFOREST) {
+            byteBluebells = 4;
+        }
+        if (biome == Biomes.OVERWORLD_GRASSLANDS) {
+            byteBluebells = 3;
+        }
+        if (biome == Biomes.OVERWORLD_CAATINGA) {
+            byteBluebells = 3;
+        }
+
+        for (int i14 = 0; i14 < byteBluebells; i14++) {
+            int k14 = x + rand.nextInt(16) + 8;
+            int l16 = minY + rand.nextInt(rangeY);
+            int k19 = z + rand.nextInt(16) + 8;
+            (new WorldFeatureFlowers(Block.flowerLightBlue.id)).generate(world, rand, k14, l16, k19);
+        }
+
         byte byte0 = 0;
         if (biome == Biomes.OVERWORLD_FOREST) {
             byte0 = 2;
@@ -329,6 +369,7 @@ public class ChunkDecoratorOverworld
         if (biome == Biomes.OVERWORLD_OUTBACK_GRASSY || biome == Biomes.OVERWORLD_OUTBACK) {
             byte0 = 2;
         }
+
         for (int i14 = 0; i14 < byte0; i14++) {
             int k14 = x + rand.nextInt(16) + 8;
             int l16 = minY + rand.nextInt(rangeY);
@@ -374,7 +415,7 @@ public class ChunkDecoratorOverworld
             byte1 = 25;
         }
         if (biome == Biomes.OVERWORLD_BIRCH_FOREST) {
-            byte1 = 10;
+            byte1 = 2;
         }
         for (int l14 = 0; l14 < byte1; l14++) {
             int type = Block.tallgrass.id;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCherry.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCherry.java
index 58c996abc..9338759c5 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCherry.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeCherry.java
@@ -15,7 +15,7 @@ public class WorldFeatureTreeCherry extends WorldFeatureTree {
 	@Override
 	public void placeLeaves(World world, int x, int y, int z, Random rand) {
 		if(rand.nextInt(5) == 0) {
-			world.setBlockAndMetadataWithNotify(x, y, z, Block.leavesCherryFlowering.id, world.seasonManager.getCurrentSeason() == Seasons.OVERWORLD_SPRING ? 1 : 0);
+			world.setBlockAndMetadataWithNotify(x, y, z, Block.leavesCherryFlowering.id, world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SPRING ? 1 : 0);
 		}else {
 			world.setBlockWithNotify(x, y, z, Block.leavesCherry.id);
 		}
diff --git a/src/main/java/net/minecraft/core/world/type/WorldType.java b/src/main/java/net/minecraft/core/world/type/WorldType.java
index 6310d9895..54c62c39f 100644
--- a/src/main/java/net/minecraft/core/world/type/WorldType.java
+++ b/src/main/java/net/minecraft/core/world/type/WorldType.java
@@ -134,19 +134,19 @@ public abstract class WorldType
 
     protected int getDayLengthTicks(World world) {
         float dayLength;
-        float seasonProgress = world.seasonManager.getSeasonProgress();
+        float seasonProgress = world.getSeasonManager().getSeasonProgress();
         if (seasonProgress < 0.5f)
         {
-            float lastSeasonDayLength = world.seasonManager.getPreviousSeason().dayLength;
-            float thisSeasonDayLength = world.seasonManager.getCurrentSeason().dayLength;
-            float seasonModifier = world.seasonManager.getSeasonModifier() * 0.5f + 0.5f;
+            float lastSeasonDayLength = world.getSeasonManager().getPreviousSeason().dayLength;
+            float thisSeasonDayLength = world.getSeasonManager().getCurrentSeason().dayLength;
+            float seasonModifier = world.getSeasonManager().getSeasonModifier() * 0.5f + 0.5f;
             dayLength = (lastSeasonDayLength * (1.0f - seasonModifier)) + (thisSeasonDayLength * seasonModifier);
         }
         else
         {
-            float thisSeasonDayLength = world.seasonManager.getCurrentSeason().dayLength;
-            float nextSeasonDayLength = world.seasonManager.getNextSeason().dayLength;
-            float seasonModifier = world.seasonManager.getSeasonModifier() * 0.5f + 0.5f;
+            float thisSeasonDayLength = world.getSeasonManager().getCurrentSeason().dayLength;
+            float nextSeasonDayLength = world.getSeasonManager().getNextSeason().dayLength;
+            float seasonModifier = world.getSeasonManager().getSeasonModifier() * 0.5f + 0.5f;
             dayLength = (thisSeasonDayLength * seasonModifier) + (nextSeasonDayLength * (1.0f - seasonModifier));
         }
 
diff --git a/src/main/java/net/minecraft/core/world/weather/Weather.java b/src/main/java/net/minecraft/core/world/weather/Weather.java
index b0a0058f4..09fe96f87 100644
--- a/src/main/java/net/minecraft/core/world/weather/Weather.java
+++ b/src/main/java/net/minecraft/core/world/weather/Weather.java
@@ -86,7 +86,7 @@ public abstract class Weather
 	
 	public void doEnvironmentUpdate(World world, Random rand, int x, int z)
 	{
-		if (world.seasonManager.getCurrentSeason() != null && !world.seasonManager.getCurrentSeason().letWeatherCleanUpSnow) return;
+		if (world.getSeasonManager().getCurrentSeason() != null && !world.getSeasonManager().getCurrentSeason().letWeatherCleanUpSnow) return;
 
 		if (rand.nextInt(4) == 0)
 		{
@@ -132,7 +132,7 @@ public abstract class Weather
 
 	public void doChunkLoadEffect(World world, Chunk chunk)
 	{
-		if (world.seasonManager.getCurrentSeason() != null && !world.seasonManager.getCurrentSeason().letWeatherCleanUpSnow) return;
+		if (world.getSeasonManager().getCurrentSeason() != null && !world.getSeasonManager().getCurrentSeason().letWeatherCleanUpSnow) return;
 
 		for (int x = 0; x < 16; x++)
 		{
diff --git a/src/main/java/net/minecraft/core/world/weather/WeatherManager.java b/src/main/java/net/minecraft/core/world/weather/WeatherManager.java
index 9771653e3..47c3d9f4b 100644
--- a/src/main/java/net/minecraft/core/world/weather/WeatherManager.java
+++ b/src/main/java/net/minecraft/core/world/weather/WeatherManager.java
@@ -88,7 +88,7 @@ public class WeatherManager {
         {
             return false;
         }
-        if (world.seasonManager.getCurrentSeason() == null)
+        if (world.getSeasonManager().getCurrentSeason() == null)
             return false;
 
         if (currentWeather == null) currentWeather = world.worldType.getDefaultWeather();
@@ -116,7 +116,7 @@ public class WeatherManager {
             if (currentWeather != world.worldType.getDefaultWeather()) {
                 nextWeather = world.worldType.getDefaultWeather();
             } else {
-                Season season = world.seasonManager.getCurrentSeason();
+                Season season = world.getSeasonManager().getCurrentSeason();
                 boolean foundWeather = false;
                 float acc = 0.0f;
                 float val = world.rand.nextFloat();
diff --git a/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java b/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
index 1f73c1f0d..da26c916c 100644
--- a/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
+++ b/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
@@ -62,7 +62,7 @@ zLoop:		for (int z = 0; z < 16; z++)
 	public void doEnvironmentUpdate(World world, Random rand, int x, int z)
 	{
 		int probability = (int)(64 * (1 / world.weatherManager.getWeatherPower()));
-		if (world.seasonManager.getCurrentSeason() != null && world.seasonManager.getCurrentSeason().hasDeeperSnow)
+		if (world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().hasDeeperSnow)
 		{
 			probability /= 2;
 		}
@@ -89,7 +89,7 @@ zLoop:		for (int z = 0; z < 16; z++)
 					world.setBlockWithNotify(x, y, z, Block.layerSnow.id);
 				}
 			}
-			else if (world.weatherManager.getWeatherPower() > 0.5f && blockId == Block.layerSnow.id && world.seasonManager.getCurrentSeason() != null && (world.seasonManager.getCurrentSeason().hasDeeperSnow || biome == Biomes.OVERWORLD_GLACIER))
+			else if (world.weatherManager.getWeatherPower() > 0.5f && blockId == Block.layerSnow.id && world.getSeasonManager().getCurrentSeason() != null && (world.getSeasonManager().getCurrentSeason().hasDeeperSnow || biome == Biomes.OVERWORLD_GLACIER))
 			{
 				if(snow) {
 					((BlockLayerSnow)Block.layerSnow).accumulate(world, x, y, z);
diff --git a/src/main/java/net/minecraft/server/entity/player/EntityPlayerMP.java b/src/main/java/net/minecraft/server/entity/player/EntityPlayerMP.java
index 5dc48367d..95cb97222 100644
--- a/src/main/java/net/minecraft/server/entity/player/EntityPlayerMP.java
+++ b/src/main/java/net/minecraft/server/entity/player/EntityPlayerMP.java
@@ -33,6 +33,7 @@ import net.minecraft.server.world.ServerPlayerController;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.player.inventory.*;
 import net.minecraft.core.player.inventory.slot.SlotCrafting;
+import net.minecraft.core.util.helper.AES;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
@@ -889,12 +890,6 @@ public class EntityPlayerMP extends EntityPlayer
         String s1 = stringtranslate.translateKey(s);
         playerNetServerHandler.sendPacket(new Packet3Chat(s1));
     }
-
-    @Override
-	public void addChatMessage(String s)
-    {
-        playerNetServerHandler.sendPacket(new Packet3Chat(I18n.getInstance().translateKey(s)));
-    }
     
     @Override
     public void setCurrentItem(int i) {
@@ -902,6 +897,16 @@ public class EntityPlayerMP extends EntityPlayer
     	playerNetServerHandler.sendPacket(new Packet16BlockItemSwitch(i));
     }
 
+	@Override
+	public void sendMessage(String message) {
+		playerNetServerHandler.sendPacket(new Packet3Chat(message, 0, AES.keyChain.get(username)));
+	}
+
+	@Override
+	public void sendStatusMessage(String message) {
+		playerNetServerHandler.sendPacket(new Packet3Chat(message, 1, AES.keyChain.get(username)));
+	}
+
     public NetServerHandler playerNetServerHandler;
     public MinecraftServer mcServer;
     public ServerPlayerController playerController;
diff --git a/src/main/java/net/minecraft/server/net/PlayerList.java b/src/main/java/net/minecraft/server/net/PlayerList.java
index 1b4542b7c..c4844558e 100644
--- a/src/main/java/net/minecraft/server/net/PlayerList.java
+++ b/src/main/java/net/minecraft/server/net/PlayerList.java
@@ -284,7 +284,7 @@ public class PlayerList
         for (int i = 0; i < playerEntities.size(); i++)
         {
             EntityPlayerMP entityplayermp = playerEntities.get(i);
-            entityplayermp.playerNetServerHandler.sendPacket(new Packet3Chat(message, AES.keyChain.get(entityplayermp.username)));
+            entityplayermp.playerNetServerHandler.sendPacket(new Packet3Chat(message, 1, AES.keyChain.get(entityplayermp.username)));
         }
 
     }
diff --git a/src/main/java/net/minecraft/server/net/handler/NetServerHandler.java b/src/main/java/net/minecraft/server/net/handler/NetServerHandler.java
index 829bf39ad..104992762 100644
--- a/src/main/java/net/minecraft/server/net/handler/NetServerHandler.java
+++ b/src/main/java/net/minecraft/server/net/handler/NetServerHandler.java
@@ -514,53 +514,43 @@ public class NetServerHandler extends NetHandler
         }
     }
 
-    @Override
-    public void handleChat(Packet3Chat packet)
-    {
-        String s;
-        if (packet.encrypted)
-        {
-            try
-            {
-                s = AES.decrypt(packet.message, AES.keyChain.get(playerEntity.username));
-            }
-            catch (Exception e)
-            {
-                throw new RuntimeException(e);
-            }
-        }
-        else
-        {
-            s = packet.message;
-        }
-        if (s.length() > 256)
-        {
-            s = s.substring(0, 255);
-        }
-        s = s.trim();
-        s = s.replace('\u00A7', '$');
-        for (int i = 0; i < s.length(); i++)
-        {
-            char c = s.charAt(i);
-            if (ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c) < 0)
-            {
-                sendPacket(new Packet3Chat(String.valueOf(TextFormatting.GRAY) + TextFormatting.ITALIC + "[SERVER] Illegal characters in chat message."));
-                return;
-            }
-        }
-
-        if (s.startsWith("/"))
-        {
-            handleSlashCommand(s);
-        }
-        else
-        {
-            s = ChatEmotes.process(s);
-            s = "<" + playerEntity.getDisplayName() + TextFormatting.RESET + "> " + TextFormatting.WHITE + s;
-            logger.info(s);
-            mcServer.playerList.sendEncryptedChatToAllPlayers(s);
-        }
-    }
+	@Override
+	public void handleChat(Packet3Chat packet) {
+		String message;
+		if(packet.encrypted) {
+			try {
+				message = AES.decrypt(packet.message, AES.keyChain.get(playerEntity.username));
+			}catch (Exception e) {
+				throw new RuntimeException(Packet3Chat.ENCRYPTION_ERROR_MESSAGE, e);
+			}
+		}else {
+			message = packet.message;
+		}
+		
+		if(message.length() > 256) {
+			message = message.substring(0, 255);
+		}
+		
+		message = message.trim();
+		message = message.replace('\u00A7', '$');
+		
+		for(int i = 0; i < message.length(); i++) {
+			char c = message.charAt(i);
+			if(ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c) < 0) {
+				sendPacket(new Packet3Chat(String.valueOf(TextFormatting.GRAY) + TextFormatting.ITALIC + "[SERVER] Illegal characters in chat message."));
+				return;
+			}
+		}
+		
+		if(message.startsWith("/")) {
+			handleSlashCommand(message);
+		}else {
+			message = ChatEmotes.process(message);
+			message = "<" + playerEntity.getDisplayName() + TextFormatting.RESET + "> " + TextFormatting.WHITE + message;
+			logger.info(message);
+			mcServer.playerList.sendEncryptedChatToAllPlayers(message);
+		}
+	}
 
     private void handleSlashCommand(String s)
     {
